<!--
  This file was generated by emdaer

  Its template can be found at .emdaer/README.emdaer.md
-->

<p></p><h1 align="center">
cache-tags
    <br>
    <img src="./logo.svg" alt="Cache Tags logo" title="Cache Tags logo" width="100">
</h1><p></p>
<p></p><p align="center">
Adds cache tags for bulk invalidation.
</p><p></p>
<hr>


<ul>
<li><a href="#install">Install</a></li>
<li><a href="#why">Why?</a></li>
<li><a href="#usage">Usage</a></li>
<li><a href="#contributors">Contributors</a></li>
<li><a href="#license">License</a></li>
</ul>

<p>· <a href="https://travis-ci.org/e0ipso/cache-tags/"><img src="https://img.shields.io/travis/e0ipso/cache-tags.svg?style=flat-square" alt="Travis"></a> <a href="https://coveralls.io/github/e0ipso/cache-tags/"><img src="https://img.shields.io/coveralls/github/e0ipso/cache-tags.svg?style=flat-square" alt="Coverage"></a> <a href="https://github.com/emdaer/emdaer"><img src="https://img.shields.io/badge/📓-documented%20with%20emdaer-F06632.svg?style=flat-square" alt="Documented with emdaer"></a></p>
<h2 id="install">Install</h2>
<ol>
<li><code>yarn add cache-tags</code></li>
<li><a href="https://redis.io/download">Install Redis</a> normally. If you want to spin up
a local cluster for testing you can use: <code>yarn create-cluster</code> and
<code>yarn destroy-cluster</code>.</li>
</ol>
<h2 id="why-">Why?</h2>
<p>If you need to invalidate cache entries that are related to each other, or just
list these cache entries that relate to each other you can use tags. You will
need to add the tags to the cache entries to be able to retrieve them later.</p>
<p>This module only supports Redis as the cache back-end at the moment. It is
tested against a single node and a cluster of 3 masters and 3 replicas.</p>
<h2 id="usage">Usage</h2>
<p>If you want to see more usage examples, check the
<a href="./__tests__/functional.js">functional tests</a>.</p>
<p>This project uses <a href="https://www.npmjs.com/package/ioredis">ioredis</a> as the Redis
client. All the options for that project are available here.</p>
<pre><code class="lang-js">const { TaggableCache: Redis } = require(&#39;cache-tags&#39;);

// Initialize the Redis client as you would using ioredis.
const redis = new Redis(&#39;127.0.0.1:6379&#39;);
// Now you can use `redis` as you would with ioredis, or you can enter tagged
// mode.
Promise.resolve()
  // Use .tags to enter tagged mode, then call set or get.
  .then(() =&gt;
    Promise.all([
      redis.tags([&#39;first-tag&#39;]).set(&#39;cache-entry-1&#39;, &#39;Lorem&#39;, 1234),
      redis.tags([&#39;first-tag&#39;, &#39;boring&#39;]).set(&#39;cache-entry-2&#39;, &#39;Ipsum&#39;, 2324),
    ])
  )
  .then(() =&gt;
    Promise.all([
      // You can scope gets by enterign tagged mode.
      redis.tags([&#39;first-tag&#39;]).get(&#39;cache-entry-1&#39;),
      // Or you can get the item as you would do normally.
      redis.get(&#39;cache-entry-2&#39;),
    ])
  )
  .then(console.log) // [&#39;Lorem&#39;, &#39;Ipsum&#39;].
  // You can also use tags to list items.
  .then(() =&gt; redis.tags([&#39;first-tag&#39;]).list())
  .then(console.log) // [&#39;Lorem&#39;, &#39;Ipsum&#39;].
  .then(() =&gt; redis.tags([&#39;boring&#39;]).list())
  .then(console.log) // [&#39;Ipsum&#39;].
  // You can also use tags to invalidate items.
  .then(() =&gt; redis.tags([&#39;first-tag&#39;]).list())
  .then(() =&gt;
    Promise.all([
      redis.tags([&#39;first-tag&#39;]).get(&#39;cache-entry-1&#39;),
      redis.get(&#39;cache-entry-2&#39;),
    ])
  )
  .then(console.log); // []. Cache entries with tag &#39;first-tag&#39; are gone.
</code></pre>
<h2 id="contributors">Contributors</h2>
<details>
<summary><strong>Contributors</strong></summary><br>
<a title="Engineer and programmer focused on online applications." href="https://github.com/e0ipso">
  <img align="left" src="https://avatars0.githubusercontent.com/u/1140906?s=24">
</a>
<strong>Mateu Aguiló Bosch</strong>
<br><br>
</details>

<h2 id="license">License</h2>
<p>cache-tags is <a href="./LICENSE">GPL-2.0 licensed</a>.</p>
